
float3 g_CameraPosition;

float  g_DieTime;
float  g_wTime;

matrix g_World;
matrix g_ViewProjection;
matrix g_WorldViewProjection;

float Speed = 1.0f;
float4 Color = float4( 0.0f, 1.0f, 0.0f, 1.0f );

float pi = 3.14159f;





struct VS_INPUT
{
    float3 pos		: POSITION;
    float3 normal	: NORMAL;
};

struct PS_INPUT
{
    float4 posP			: SV_POSITION;
    float4 posW			: TEXCOORD1;
    float3 normalW		: NORMAL;
    float4 color		: COLOR0;
};









float3 calcPos(float3 pos)
{
	float3 posModel = pos;
	
	float progressT = clamp((g_wTime - g_DieTime)/2,0,1);
	float progress = (progressT * (0.1 / clamp(posModel.y+0.5,0,1)) + (1-progressT)* (0.4));

	posModel.x = progress * posModel.x;
	posModel.z = progress * posModel.z;
	posModel.y += 0.5;
	posModel.y *= (0.1 + 0.9*(1-progressT));
	
	return posModel;
}

float3 calcNormal(float3 pos)
{	
	return float3(0,1,0);
}




PS_INPUT VS( VS_INPUT input)
{
    PS_INPUT output;
    
    float3 normal = calcNormal(input.pos);
    float3 posModel = calcPos(input.pos);
    
    
    output.posW = mul( float4(posModel,1), g_World );    
    output.posP = mul( output.posW, g_ViewProjection ); 
	output.normalW = normalize( float4(mul(normal, (float3x3) g_World),1));
	output.color = float4(0,0,0,0.3) + float4(0,0,0,0.8);

    return output;
}

void PS( PS_INPUT input, 
		   out float4 color  : SV_Target0,
		   out float4 normal : SV_Target1,
		   out float4 pos	 : SV_Target2 )
{   
	pos = input.posW;
    color = float4(Color.r,Color.g,Color.b,1.0f) * (1-(g_wTime-g_DieTime)/2);
    normal = float4(normalize(input.normalW),1);
}
































BlendState SrcAlphaBlendingAdd
{
    BlendEnable[0] = TRUE;
    SrcBlend = SRC_ALPHA;
    DestBlend = INV_SRC_ALPHA;
    BlendOp = ADD;
    SrcBlendAlpha = ZERO;
    DestBlendAlpha = ZERO;
    BlendOpAlpha = ADD;
    RenderTargetWriteMask[0] = 0x0F;
};

technique10 Default
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
        SetBlendState( SrcAlphaBlendingAdd, float4( 0.0f, 0.0f, 0.0f, 0.0f ), 0xFFFFFFFF );
    }
}