
matrix g_World;
matrix g_ViewProjection;
matrix g_WorldViewProjection;

float4 Color = float4( 0.0f, 1.0f, 0.0f, 1.0f );

bool g_WriteToPpTarget = false;



struct VS_INPUT
{
    float3 pos		: POSITION;
};

struct PS_INPUT
{
    float4 posP		: SV_POSITION;
    float4 posW		: TEXCOORD1;
    float3 normalW  : NORMAL;
};




PS_INPUT VS( VS_INPUT input)
{
    PS_INPUT output;
    
    output.posW = mul( float4(input.pos,1), g_World );    
    output.posP = mul( output.posW, g_ViewProjection ); 
	output.normalW = normalize( float4(mul(float3(0,2,0)+ input.pos, (float3x3) g_World),1));
	
    return output;
}

void PS( PS_INPUT input, 
		   out float4 color  : SV_Target0,
		   out float4 normal : SV_Target1,
		   out float4 pos	 : SV_Target2,
		   out float4 pp_normal	: SV_Target3 )
{   
	pos = input.posW;
    color = float4(Color.rgb,1);
    normal = float4(normalize(input.normalW),1);
    
    if ( g_WriteToPpTarget ) 
    {
		pp_normal = normal;
	}
	else pp_normal = float4(0,0,0,0);
}










technique10 Default
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
    }
}