
Texture2D g_tex;

SamplerState samLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};



float3 PixelCoordsDownFilter[16] =
{
    { 1.5,  -1.5        , 1.0/16.0 },
    { 1.5,  -0.5        , 1.0/16.0 },
    { 1.5,   0.5        , 1.0/16.0 },
    { 1.5,   1.5        , 1.0/16.0 },

    { 0.5,  -1.5        , 1.0/16.0 },
    { 0.5,  -0.5        , 1.0/16.0 },
    { 0.5,   0.5        , 1.0/16.0 },
    { 0.5,   1.5        , 1.0/16.0 },

    {-0.5,  -1.5        , 1.0/16.0 },
    {-0.5,  -0.5        , 1.0/16.0 },
    {-0.5,   0.5        , 1.0/16.0 },
    {-0.5,   1.5        , 1.0/16.0 },

    {-1.5,  -1.5        , 1.0/16.0 },
    {-1.5,  -0.5        , 1.0/16.0 },
    {-1.5,   0.5        , 1.0/16.0 },
    {-1.5,   1.5        , 1.0/16.0 }
};





void PS(  in	float4 pos		: SV_POSITION,
		  in	float2 tex		: TEXCOORD0,
		  out	float4 col		: SV_TARGET )
{

    float4 Color = 0;

    for (int i = 0; i < 16; i++)
    {
        Color += g_tex.Sample( samLinear, tex + PixelCoordsDownFilter[i].xy *0.001 ) * PixelCoordsDownFilter[i].z;
    }

    col = Color;
}

void VS( inout		float4 pos		: SV_POSITION,
		 inout		float2 tex		: TEXCOORD0) 
{ 
	tex = (pos.xy + float2(1,1)) / 2;
	tex.y = 1-tex.y;
}










RasterizerState rsNoCulling 
{ 
	CullMode = None; 
};
DepthStencilState DepthEnabling
 {
     DepthEnable = FALSE;
 };


technique10 PostProcess
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
   
         SetDepthStencilState(DepthEnabling, 0);     
        SetRasterizerState( rsNoCulling );
    }
}