
Texture2D g_texPosition;
Texture2D g_texNormal;
float3 g_CameraPosition;


SamplerState samLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

int g_KernelSize = 5;
float2 PixelKernel[5] =
{
    { 0,  1},
    { 1,  0},
    { 0, -1},
    {-1,  0},
    { 0,  0}
};

void PS(  in	float4 pos		: SV_POSITION,
		  in	float2 tex		: TEXCOORD0,
		  out	float4 col		: SV_TARGET )
{
    float f = 0;
    float _f;
    
    for( int i = 0; i < g_KernelSize; i++ )
    {
        _f =  1 - abs(
                        dot( 
                                normalize( g_CameraPosition- g_texPosition.Sample( samLinear, tex + PixelKernel[i] * 0.001 ) ),
                                normalize(                                   g_texNormal  .Sample( samLinear, tex + PixelKernel[i] * 0.001 ) )
                            )
                      );
                
        if ( _f > 0.7 ) f += _f;
    }
    
    
    if (f != 0) col = float4( float3(1,1,1)  ,f);
    else clip(-1);
}

void VS( inout		float4 pos		: SV_POSITION,
		 inout		float2 tex		: TEXCOORD0) 
{ 
	tex = (pos.xy + float2(1,1)) / 2;
	tex.y = 1-tex.y;
}









DepthStencilState DepthEnabling
 {
     DepthEnable = FALSE;
 };


technique10 EdgeGlow
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
   
        SetDepthStencilState(DepthEnabling, 0);
    }
}